// services/network/public/mojom/attribution.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_ATTRIBUTION_MOJOM_SHARED_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_ATTRIBUTION_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/attribution.mojom-shared-internal.h"







namespace network::mojom {
class TriggerVerificationDataView;

class AttributionReportingRuntimeFeaturesDataView;



}  // network::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::network::mojom::TriggerVerificationDataView> {
  using Data = ::network::mojom::internal::TriggerVerification_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::network::mojom::AttributionReportingRuntimeFeaturesDataView> {
  using Data = ::network::mojom::internal::AttributionReportingRuntimeFeatures_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace network::mojom {


enum class AttributionSupport : int32_t {
  
  kWeb = 0,
  
  kWebAndOs = 1,
  
  kOs = 2,
  
  kNone = 3,
  kMinValue = 0,
  kMaxValue = 3,
};

 std::ostream& operator<<(std::ostream& os, AttributionSupport value);
inline bool IsKnownEnumValue(AttributionSupport value) {
  return internal::AttributionSupport_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


enum class AttributionReportingEligibility : int32_t {
  
  kUnset = 0,
  
  kEmpty = 1,
  
  kEventSource = 2,
  
  kNavigationSource = 3,
  
  kTrigger = 4,
  
  kEventSourceOrTrigger = 5,
  kMinValue = 0,
  kMaxValue = 5,
};

 std::ostream& operator<<(std::ostream& os, AttributionReportingEligibility value);
inline bool IsKnownEnumValue(AttributionReportingEligibility value) {
  return internal::AttributionReportingEligibility_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


class TriggerVerificationDataView {
 public:
  TriggerVerificationDataView() = default;

  TriggerVerificationDataView(
      internal::TriggerVerification_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetTokenDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadToken(UserType* output) {
    
    auto* pointer = data_->token.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetAggregatableReportIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadAggregatableReportId(UserType* output) {
    
    auto* pointer = data_->aggregatable_report_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
 private:
  internal::TriggerVerification_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class AttributionReportingRuntimeFeaturesDataView {
 public:
  AttributionReportingRuntimeFeaturesDataView() = default;

  AttributionReportingRuntimeFeaturesDataView(
      internal::AttributionReportingRuntimeFeatures_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool cross_app_web_enabled() const {
    return data_->cross_app_web_enabled;
  }
 private:
  internal::AttributionReportingRuntimeFeatures_Data* data_ = nullptr;
};


}  // network::mojom

namespace std {

template <>
struct hash<::network::mojom::AttributionSupport>
    : public mojo::internal::EnumHashImpl<::network::mojom::AttributionSupport> {};

template <>
struct hash<::network::mojom::AttributionReportingEligibility>
    : public mojo::internal::EnumHashImpl<::network::mojom::AttributionReportingEligibility> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::AttributionSupport, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::network::mojom::AttributionSupport, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::network::mojom::AttributionSupport>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::AttributionReportingEligibility, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::network::mojom::AttributionReportingEligibility, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::network::mojom::AttributionReportingEligibility>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::TriggerVerificationDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::network::mojom::TriggerVerificationDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::network::mojom::internal::TriggerVerification_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::token(input)) in_token = Traits::token(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->token)::BaseType> token_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_token, token_fragment);
    fragment->token.Set(
        token_fragment.is_null() ? nullptr : token_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->token.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null token in TriggerVerification struct");
    decltype(Traits::aggregatable_report_id(input)) in_aggregatable_report_id = Traits::aggregatable_report_id(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->aggregatable_report_id)::BaseType> aggregatable_report_id_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_aggregatable_report_id, aggregatable_report_id_fragment);
    fragment->aggregatable_report_id.Set(
        aggregatable_report_id_fragment.is_null() ? nullptr : aggregatable_report_id_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->aggregatable_report_id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null aggregatable_report_id in TriggerVerification struct");
  }

  static bool Deserialize(::network::mojom::internal::TriggerVerification_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::network::mojom::TriggerVerificationDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::network::mojom::AttributionReportingRuntimeFeaturesDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::network::mojom::AttributionReportingRuntimeFeaturesDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::network::mojom::internal::AttributionReportingRuntimeFeatures_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->cross_app_web_enabled = Traits::cross_app_web_enabled(input);
  }

  static bool Deserialize(::network::mojom::internal::AttributionReportingRuntimeFeatures_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::network::mojom::AttributionReportingRuntimeFeaturesDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace network::mojom {

inline void TriggerVerificationDataView::GetTokenDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->token.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void TriggerVerificationDataView::GetAggregatableReportIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->aggregatable_report_id.Get();
  *output = mojo::StringDataView(pointer, message_);
}





}  // network::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct  TraceFormatTraits<::network::mojom::AttributionSupport> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::network::mojom::AttributionSupport value);
};

} // namespace perfetto

namespace perfetto {

template <>
struct  TraceFormatTraits<::network::mojom::AttributionReportingEligibility> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::network::mojom::AttributionReportingEligibility value);
};

} // namespace perfetto

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_ATTRIBUTION_MOJOM_SHARED_H_