// services/viz/public/mojom/compositing/transferable_resource.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_TRANSFERABLE_RESOURCE_MOJOM_BLINK_H_
#define SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_TRANSFERABLE_RESOURCE_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/viz/public/mojom/compositing/transferable_resource.mojom-features.h"
#include "services/viz/public/mojom/compositing/transferable_resource.mojom-shared.h"
#include "services/viz/public/mojom/compositing/transferable_resource.mojom-blink-forward.h"
#include "gpu/ipc/common/mailbox_holder.mojom-blink.h"
#include "gpu/ipc/common/vulkan_ycbcr_info.mojom-blink.h"
#include "services/viz/public/mojom/compositing/shared_image_format.mojom-blink.h"
#include "services/viz/public/mojom/compositing/resource_id.mojom-blink.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-blink.h"
#include "ui/gfx/mojom/color_space.mojom-blink.h"
#include "ui/gfx/mojom/hdr_metadata.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "third_party/blink/public/platform/web_common.h"




namespace viz::mojom::blink {








class BLINK_PLATFORM_EXPORT TransferableResource {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<TransferableResource, T>::value>;
  using DataView = TransferableResourceDataView;
  using Data_ = internal::TransferableResource_Data;

  template <typename... Args>
  static TransferableResourcePtr New(Args&&... args) {
    return TransferableResourcePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static TransferableResourcePtr From(const U& u) {
    return mojo::TypeConverter<TransferableResourcePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, TransferableResource>::Convert(*this);
  }


  TransferableResource();

  TransferableResource(
      ::viz::mojom::blink::ResourceIdPtr id,
      ::viz::mojom::blink::SharedImageFormatPtr format,
      const ::gfx::Size& size,
      const ::gpu::MailboxHolder& mailbox_holder,
      SynchronizationType synchronization_type,
      bool is_software,
      bool is_overlay_candidate,
      bool is_backed_by_surface_texture,
      bool wants_promotion_hint,
      const ::gfx::ColorSpace& color_space,
      ::gfx::mojom::blink::HDRMetadataPtr hdr_metadata,
      ::gpu::mojom::blink::VulkanYCbCrInfoPtr ycbcr_info);

TransferableResource(const TransferableResource&) = delete;
TransferableResource& operator=(const TransferableResource&) = delete;

  ~TransferableResource();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = TransferableResourcePtr>
  TransferableResourcePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, TransferableResource::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, TransferableResource::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, TransferableResource::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        TransferableResource::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        TransferableResource::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::TransferableResource_UnserializedMessageContext<
            UserType, TransferableResource::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<TransferableResource::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return TransferableResource::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::TransferableResource_UnserializedMessageContext<
            UserType, TransferableResource::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<TransferableResource::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::viz::mojom::blink::ResourceIdPtr id;
  
  ::viz::mojom::blink::SharedImageFormatPtr format;
  
  ::gfx::Size size;
  
  ::gpu::MailboxHolder mailbox_holder;
  
  SynchronizationType synchronization_type;
  
  bool is_software;
  
  bool is_overlay_candidate;
  
  bool is_backed_by_surface_texture;
  
  bool wants_promotion_hint;
  
  ::gfx::ColorSpace color_space;
  
  ::gfx::mojom::blink::HDRMetadataPtr hdr_metadata;
  
  ::gpu::mojom::blink::VulkanYCbCrInfoPtr ycbcr_info;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, TransferableResource::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, TransferableResource::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, TransferableResource::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, TransferableResource::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
TransferableResourcePtr TransferableResource::Clone() const {
  return New(
      mojo::Clone(id),
      mojo::Clone(format),
      mojo::Clone(size),
      mojo::Clone(mailbox_holder),
      mojo::Clone(synchronization_type),
      mojo::Clone(is_software),
      mojo::Clone(is_overlay_candidate),
      mojo::Clone(is_backed_by_surface_texture),
      mojo::Clone(wants_promotion_hint),
      mojo::Clone(color_space),
      mojo::Clone(hdr_metadata),
      mojo::Clone(ycbcr_info)
  );
}

template <typename T, TransferableResource::EnableIfSame<T>*>
bool TransferableResource::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->id, other_struct.id))
    return false;
  if (!mojo::Equals(this->format, other_struct.format))
    return false;
  if (!mojo::Equals(this->size, other_struct.size))
    return false;
  if (!mojo::Equals(this->mailbox_holder, other_struct.mailbox_holder))
    return false;
  if (!mojo::Equals(this->synchronization_type, other_struct.synchronization_type))
    return false;
  if (!mojo::Equals(this->is_software, other_struct.is_software))
    return false;
  if (!mojo::Equals(this->is_overlay_candidate, other_struct.is_overlay_candidate))
    return false;
  if (!mojo::Equals(this->is_backed_by_surface_texture, other_struct.is_backed_by_surface_texture))
    return false;
  if (!mojo::Equals(this->wants_promotion_hint, other_struct.wants_promotion_hint))
    return false;
  if (!mojo::Equals(this->color_space, other_struct.color_space))
    return false;
  if (!mojo::Equals(this->hdr_metadata, other_struct.hdr_metadata))
    return false;
  if (!mojo::Equals(this->ycbcr_info, other_struct.ycbcr_info))
    return false;
  return true;
}

template <typename T, TransferableResource::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.id < rhs.id)
    return true;
  if (rhs.id < lhs.id)
    return false;
  if (lhs.format < rhs.format)
    return true;
  if (rhs.format < lhs.format)
    return false;
  if (lhs.size < rhs.size)
    return true;
  if (rhs.size < lhs.size)
    return false;
  if (lhs.mailbox_holder < rhs.mailbox_holder)
    return true;
  if (rhs.mailbox_holder < lhs.mailbox_holder)
    return false;
  if (lhs.synchronization_type < rhs.synchronization_type)
    return true;
  if (rhs.synchronization_type < lhs.synchronization_type)
    return false;
  if (lhs.is_software < rhs.is_software)
    return true;
  if (rhs.is_software < lhs.is_software)
    return false;
  if (lhs.is_overlay_candidate < rhs.is_overlay_candidate)
    return true;
  if (rhs.is_overlay_candidate < lhs.is_overlay_candidate)
    return false;
  if (lhs.is_backed_by_surface_texture < rhs.is_backed_by_surface_texture)
    return true;
  if (rhs.is_backed_by_surface_texture < lhs.is_backed_by_surface_texture)
    return false;
  if (lhs.wants_promotion_hint < rhs.wants_promotion_hint)
    return true;
  if (rhs.wants_promotion_hint < lhs.wants_promotion_hint)
    return false;
  if (lhs.color_space < rhs.color_space)
    return true;
  if (rhs.color_space < lhs.color_space)
    return false;
  if (lhs.hdr_metadata < rhs.hdr_metadata)
    return true;
  if (rhs.hdr_metadata < lhs.hdr_metadata)
    return false;
  if (lhs.ycbcr_info < rhs.ycbcr_info)
    return true;
  if (rhs.ycbcr_info < lhs.ycbcr_info)
    return false;
  return false;
}


}  // viz::mojom::blink

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::viz::mojom::blink::TransferableResource::DataView,
                                         ::viz::mojom::blink::TransferableResourcePtr> {
  static bool IsNull(const ::viz::mojom::blink::TransferableResourcePtr& input) { return !input; }
  static void SetToNull(::viz::mojom::blink::TransferableResourcePtr* output) { output->reset(); }

  static const decltype(::viz::mojom::blink::TransferableResource::id)& id(
      const ::viz::mojom::blink::TransferableResourcePtr& input) {
    return input->id;
  }

  static const decltype(::viz::mojom::blink::TransferableResource::format)& format(
      const ::viz::mojom::blink::TransferableResourcePtr& input) {
    return input->format;
  }

  static const decltype(::viz::mojom::blink::TransferableResource::size)& size(
      const ::viz::mojom::blink::TransferableResourcePtr& input) {
    return input->size;
  }

  static const decltype(::viz::mojom::blink::TransferableResource::mailbox_holder)& mailbox_holder(
      const ::viz::mojom::blink::TransferableResourcePtr& input) {
    return input->mailbox_holder;
  }

  static decltype(::viz::mojom::blink::TransferableResource::synchronization_type) synchronization_type(
      const ::viz::mojom::blink::TransferableResourcePtr& input) {
    return input->synchronization_type;
  }

  static decltype(::viz::mojom::blink::TransferableResource::is_software) is_software(
      const ::viz::mojom::blink::TransferableResourcePtr& input) {
    return input->is_software;
  }

  static decltype(::viz::mojom::blink::TransferableResource::is_overlay_candidate) is_overlay_candidate(
      const ::viz::mojom::blink::TransferableResourcePtr& input) {
    return input->is_overlay_candidate;
  }

  static decltype(::viz::mojom::blink::TransferableResource::is_backed_by_surface_texture) is_backed_by_surface_texture(
      const ::viz::mojom::blink::TransferableResourcePtr& input) {
    return input->is_backed_by_surface_texture;
  }

  static decltype(::viz::mojom::blink::TransferableResource::wants_promotion_hint) wants_promotion_hint(
      const ::viz::mojom::blink::TransferableResourcePtr& input) {
    return input->wants_promotion_hint;
  }

  static const decltype(::viz::mojom::blink::TransferableResource::color_space)& color_space(
      const ::viz::mojom::blink::TransferableResourcePtr& input) {
    return input->color_space;
  }

  static const decltype(::viz::mojom::blink::TransferableResource::hdr_metadata)& hdr_metadata(
      const ::viz::mojom::blink::TransferableResourcePtr& input) {
    return input->hdr_metadata;
  }

  static const decltype(::viz::mojom::blink::TransferableResource::ycbcr_info)& ycbcr_info(
      const ::viz::mojom::blink::TransferableResourcePtr& input) {
    return input->ycbcr_info;
  }

  static bool Read(::viz::mojom::blink::TransferableResource::DataView input, ::viz::mojom::blink::TransferableResourcePtr* output);
};

}  // namespace mojo

#endif  // SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_TRANSFERABLE_RESOURCE_MOJOM_BLINK_H_