// Copyright 2014 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/web_runtime_features_base.h.tmpl
// and input files:
//   ../../../../../src/3rdparty/chromium/third_party/blink/renderer/platform/runtime_enabled_features.json5


#ifndef THIRD_PARTY_BLINK_PUBLIC_PLATFORM_WEB_RUNTIME_FEATURES_BASE_H_
#define THIRD_PARTY_BLINK_PUBLIC_PLATFORM_WEB_RUNTIME_FEATURES_BASE_H_

#include "third_party/blink/public/platform/web_common.h"

namespace blink {

class BLINK_PLATFORM_EXPORT WebRuntimeFeaturesBase {
 public:
  static void EnableAccessibilityAriaVirtualContent(bool);
  static bool IsAccessibilityAriaVirtualContentEnabled();
  static void EnableAccessibilityExposeHTMLElement(bool);
  static bool IsAccessibilityExposeHTMLElementEnabled();
  static void EnableAccessibilityExposeIgnoredNodes(bool);
  static bool IsAccessibilityExposeIgnoredNodesEnabled();
  static void EnableAccessibilityOSLevelBoldText(bool);
  static bool IsAccessibilityOSLevelBoldTextEnabled();
  static void EnableAccessibilityPageZoom(bool);
  static bool IsAccessibilityPageZoomEnabled();
  static void EnableAccessibilityUseAXPositionForDocumentMarkers(bool);
  static bool IsAccessibilityUseAXPositionForDocumentMarkersEnabled();
  static void EnableAddIdentityInCanMakePaymentEvent(bool);
  static bool IsAddIdentityInCanMakePaymentEventEnabled();
  static void EnableAdInterestGroupAPI(bool);
  static bool IsAdInterestGroupAPIEnabled();
  static void EnableAdTagging(bool);
  static bool IsAdTaggingEnabled();
  static void EnableAndroidDownloadableFontsMatching(bool);
  static bool IsAndroidDownloadableFontsMatchingEnabled();
  static void EnableAnonymousIframe(bool);
  static bool IsAnonymousIframeEnabled();
  static void EnableAOMAriaRelationshipProperties(bool);
  static bool IsAOMAriaRelationshipPropertiesEnabled();
  static void EnableAttributionReporting(bool);
  static bool IsAttributionReportingEnabled();
  static void EnableAttributionReportingCrossAppWeb(bool);
  static bool IsAttributionReportingCrossAppWebEnabled();
  static void EnableAutoDisableAccessibilityV2(bool);
  static bool IsAutoDisableAccessibilityV2Enabled();
  static void EnableAutomationControlled(bool);
  static bool IsAutomationControlledEnabled();
  static void EnableAutoplayIgnoresWebAudio(bool);
  static bool IsAutoplayIgnoresWebAudioEnabled();
  static void EnableBackForwardCache(bool);
  static bool IsBackForwardCacheEnabled();
  static void EnableBackgroundFetch(bool);
  static bool IsBackgroundFetchEnabled();
  static void EnableBeforeunloadEventCancelByPreventDefault(bool);
  static bool IsBeforeunloadEventCancelByPreventDefaultEnabled();
  static void EnableBoundaryEventDispatchTracksNodeRemoval(bool);
  static bool IsBoundaryEventDispatchTracksNodeRemovalEnabled();
  static void EnableBrowserVerifiedUserActivationKeyboard(bool);
  static bool IsBrowserVerifiedUserActivationKeyboardEnabled();
  static void EnableBrowserVerifiedUserActivationMouse(bool);
  static bool IsBrowserVerifiedUserActivationMouseEnabled();
  static void EnableCanvas2dImageChromium(bool);
  static bool IsCanvas2dImageChromiumEnabled();
  static void EnableCompositeBGColorAnimation(bool);
  static bool IsCompositeBGColorAnimationEnabled();
  static void EnableCompositeClipPathAnimation(bool);
  static bool IsCompositeClipPathAnimationEnabled();
  static void EnableCompositedSelectionUpdate(bool);
  static bool IsCompositedSelectionUpdateEnabled();
  static void EnableCompressionDictionaryTransport(bool);
  static bool IsCompressionDictionaryTransportEnabled();
  static void EnableCompressionDictionaryTransportBackend(bool);
  static bool IsCompressionDictionaryTransportBackendEnabled();
  static void EnableConsolidatedMovementXY(bool);
  static bool IsConsolidatedMovementXYEnabled();
  static void EnableCooperativeScheduling(bool);
  static bool IsCooperativeSchedulingEnabled();
  static void EnableDatabase(bool);
  static bool IsDatabaseEnabled();
  static void EnableDevicePosture(bool);
  static bool IsDevicePostureEnabled();
  static void EnableDigitalGoods(bool);
  static bool IsDigitalGoodsEnabled();
  static void EnableDirectSockets(bool);
  static bool IsDirectSocketsEnabled();
  static void EnableDisplayCutoutAPI(bool);
  static bool IsDisplayCutoutAPIEnabled();
  static void EnableDocumentPolicyNegotiation(bool);
  static bool IsDocumentPolicyNegotiationEnabled();
  static void EnableFedCm(bool);
  static bool IsFedCmEnabled();
  static void EnableFedCmAuthz(bool);
  static bool IsFedCmAuthzEnabled();
  static void EnableFedCmAutoSelectedFlag(bool);
  static bool IsFedCmAutoSelectedFlagEnabled();
  static void EnableFedCmButtonMode(bool);
  static bool IsFedCmButtonModeEnabled();
  static void EnableFedCmDisconnect(bool);
  static bool IsFedCmDisconnectEnabled();
  static void EnableFedCmDomainHint(bool);
  static bool IsFedCmDomainHintEnabled();
  static void EnableFedCmError(bool);
  static bool IsFedCmErrorEnabled();
  static void EnableFedCmIdPRegistration(bool);
  static bool IsFedCmIdPRegistrationEnabled();
  static void EnableFedCmIdpSigninStatus(bool);
  static bool IsFedCmIdpSigninStatusEnabled();
  static void EnableFedCmMultipleIdentityProviders(bool);
  static bool IsFedCmMultipleIdentityProvidersEnabled();
  static void EnableFedCmSelectiveDisclosure(bool);
  static bool IsFedCmSelectiveDisclosureEnabled();
  static void EnableFencedFrames(bool);
  static bool IsFencedFramesEnabled();
  static void EnableFencedFramesDefaultMode(bool);
  static bool IsFencedFramesDefaultModeEnabled();
  static void EnableFencedFramesLocalUnpartitionedDataAccess(bool);
  static bool IsFencedFramesLocalUnpartitionedDataAccessEnabled();
  static void EnableFileSystem(bool);
  static bool IsFileSystemEnabled();
  static void EnableFledge(bool);
  static bool IsFledgeEnabled();
  static void EnableFledgeFeatureDetection(bool);
  static bool IsFledgeFeatureDetectionEnabled();
  static void EnableForcedColors(bool);
  static bool IsForcedColorsEnabled();
  static void EnableFractionalScrollOffsets(bool);
  static bool IsFractionalScrollOffsetsEnabled();
  static void EnableGamepadMultitouch(bool);
  static bool IsGamepadMultitouchEnabled();
  static void EnableGetAllScreensMedia(bool);
  static bool IsGetAllScreensMediaEnabled();
  static void EnableGetDisplayMedia(bool);
  static bool IsGetDisplayMediaEnabled();
  static void EnableImplicitRootScroller(bool);
  static bool IsImplicitRootScrollerEnabled();
  static void EnableInstalledApp(bool);
  static bool IsInstalledAppEnabled();
  static void EnableLazyInitializeMediaControls(bool);
  static bool IsLazyInitializeMediaControlsEnabled();
  static void EnableLazyLoadScrollMargin(bool);
  static bool IsLazyLoadScrollMarginEnabled();
  static void EnableLockedMode(bool);
  static bool IsLockedModeEnabled();
  static void EnableMachineLearningModelLoader(bool);
  static bool IsMachineLearningModelLoaderEnabled();
  static void EnableMachineLearningNeuralNetwork(bool);
  static bool IsMachineLearningNeuralNetworkEnabled();
  static void EnableMediaCastOverlayButton(bool);
  static bool IsMediaCastOverlayButtonEnabled();
  static void EnableMediaControlsExpandGesture(bool);
  static bool IsMediaControlsExpandGestureEnabled();
  static void EnableMediaControlsOverlayPlayButton(bool);
  static bool IsMediaControlsOverlayPlayButtonEnabled();
  static void EnableMediaEngagementBypassAutoplayPolicies(bool);
  static bool IsMediaEngagementBypassAutoplayPoliciesEnabled();
  static void EnableMediaSession(bool);
  static bool IsMediaSessionEnabled();
  static void EnableMediaSessionEnterPictureInPicture(bool);
  static bool IsMediaSessionEnterPictureInPictureEnabled();
  static void EnableNetInfoDownlinkMax(bool);
  static bool IsNetInfoDownlinkMaxEnabled();
  static void EnableNonComposedEnterLeaveEvents(bool);
  static bool IsNonComposedEnterLeaveEventsEnabled();
  static void EnableNotificationContentImage(bool);
  static bool IsNotificationContentImageEnabled();
  static void EnableNotifications(bool);
  static bool IsNotificationsEnabled();
  static void EnableObservableAPI(bool);
  static bool IsObservableAPIEnabled();
  static void EnablePaymentApp(bool);
  static bool IsPaymentAppEnabled();
  static void EnablePaymentRequest(bool);
  static bool IsPaymentRequestEnabled();
  static void EnablePaymentRequestAllowOneActivationlessShow(bool);
  static bool IsPaymentRequestAllowOneActivationlessShowEnabled();
  static void EnablePendingBeaconAPI(bool);
  static bool IsPendingBeaconAPIEnabled();
  static void EnablePercentBasedScrolling(bool);
  static bool IsPercentBasedScrollingEnabled();
  static void EnablePerformanceManagerInstrumentation(bool);
  static bool IsPerformanceManagerInstrumentationEnabled();
  static void EnablePeriodicBackgroundSync(bool);
  static bool IsPeriodicBackgroundSyncEnabled();
  static void EnablePermissions(bool);
  static bool IsPermissionsEnabled();
  static void EnablePreciseMemoryInfo(bool);
  static bool IsPreciseMemoryInfoEnabled();
  static void EnablePresentation(bool);
  static bool IsPresentationEnabled();
  static void EnablePrivateNetworkAccessPermissionPrompt(bool);
  static bool IsPrivateNetworkAccessPermissionPromptEnabled();
  static void EnablePrivateStateTokens(bool);
  static bool IsPrivateStateTokensEnabled();
  static void EnablePrivateStateTokensAlwaysAllowIssuance(bool);
  static bool IsPrivateStateTokensAlwaysAllowIssuanceEnabled();
  static void EnablePushMessaging(bool);
  static bool IsPushMessagingEnabled();
  static void EnablePushMessagingSubscriptionChange(bool);
  static bool IsPushMessagingSubscriptionChangeEnabled();
  static void EnableRemotePlayback(bool);
  static bool IsRemotePlaybackEnabled();
  static void EnableRemoveMobileViewportDoubleTap(bool);
  static bool IsRemoveMobileViewportDoubleTapEnabled();
  static void EnableRestrictGamepadAccess(bool);
  static bool IsRestrictGamepadAccessEnabled();
  static void EnableScriptedSpeechRecognition(bool);
  static bool IsScriptedSpeechRecognitionEnabled();
  static void EnableScriptedSpeechSynthesis(bool);
  static bool IsScriptedSpeechSynthesisEnabled();
  static void EnableSecurePaymentConfirmation(bool);
  static bool IsSecurePaymentConfirmationEnabled();
  static void EnableSecurePaymentConfirmationAllowOneActivationlessShow(bool);
  static bool IsSecurePaymentConfirmationAllowOneActivationlessShowEnabled();
  static void EnableSecurePaymentConfirmationDebug(bool);
  static bool IsSecurePaymentConfirmationDebugEnabled();
  static void EnableSecurePaymentConfirmationExtensions(bool);
  static bool IsSecurePaymentConfirmationExtensionsEnabled();
  static void EnableSendBeaconThrowForBlobWithNonSimpleType(bool);
  static bool IsSendBeaconThrowForBlobWithNonSimpleTypeEnabled();
  static void EnableSensorExtraClasses(bool);
  static bool IsSensorExtraClassesEnabled();
  static void EnableServiceWorkerBypassFetchHandler(bool);
  static bool IsServiceWorkerBypassFetchHandlerEnabled();
  static void EnableServiceWorkerRaceNetworkRequest(bool);
  static bool IsServiceWorkerRaceNetworkRequestEnabled();
  static void EnableServiceWorkerStaticRouter(bool);
  static bool IsServiceWorkerStaticRouterEnabled();
  static void EnableSharedArrayBuffer(bool);
  static bool IsSharedArrayBufferEnabled();
  static void EnableSharedArrayBufferOnDesktop(bool);
  static bool IsSharedArrayBufferOnDesktopEnabled();
  static void EnableSharedArrayBufferUnrestrictedAccessAllowed(bool);
  static bool IsSharedArrayBufferUnrestrictedAccessAllowedEnabled();
  static void EnableSharedAutofill(bool);
  static bool IsSharedAutofillEnabled();
  static void EnableSharedStorageAPI(bool);
  static bool IsSharedStorageAPIEnabled();
  static void EnableSharedStorageAPIM118(bool);
  static bool IsSharedStorageAPIM118Enabled();
  static void EnableSharedWorker(bool);
  static bool IsSharedWorkerEnabled();
  static void EnableSmartZoom(bool);
  static bool IsSmartZoomEnabled();
  static void EnableTextFragmentIdentifiers(bool);
  static bool IsTextFragmentIdentifiersEnabled();
  static void EnableTimerThrottlingForBackgroundTabs(bool);
  static bool IsTimerThrottlingForBackgroundTabsEnabled();
  static void EnableTopicsAPI(bool);
  static bool IsTopicsAPIEnabled();
  static void EnableTopicsDocumentAPI(bool);
  static bool IsTopicsDocumentAPIEnabled();
  static void EnableTouchDragAndContextMenu(bool);
  static bool IsTouchDragAndContextMenuEnabled();
  static void EnableTouchEventFeatureDetection(bool);
  static bool IsTouchEventFeatureDetectionEnabled();
  static void EnableUserActivationSameOriginVisibility(bool);
  static bool IsUserActivationSameOriginVisibilityEnabled();
  static void EnableV8IdleTasks(bool);
  static bool IsV8IdleTasksEnabled();
  static void EnableVideoPlaybackQuality(bool);
  static bool IsVideoPlaybackQualityEnabled();
  static void EnableViewportSegments(bool);
  static bool IsViewportSegmentsEnabled();
  static void EnableWebAuthenticationRemoteDesktopSupport(bool);
  static bool IsWebAuthenticationRemoteDesktopSupportEnabled();
  static void EnableWebBluetooth(bool);
  static bool IsWebBluetoothEnabled();
  static void EnableWebBluetoothGetDevices(bool);
  static bool IsWebBluetoothGetDevicesEnabled();
  static void EnableWebBluetoothWatchAdvertisements(bool);
  static bool IsWebBluetoothWatchAdvertisementsEnabled();
  static void EnableWebGLDeveloperExtensions(bool);
  static bool IsWebGLDeveloperExtensionsEnabled();
  static void EnableWebGLDraftExtensions(bool);
  static bool IsWebGLDraftExtensionsEnabled();
  static void EnableWebGLImageChromium(bool);
  static bool IsWebGLImageChromiumEnabled();
  static void EnableWebGPUDeveloperFeatures(bool);
  static bool IsWebGPUDeveloperFeaturesEnabled();
  static void EnableWebHIDOnServiceWorkers(bool);
  static bool IsWebHIDOnServiceWorkersEnabled();
  static void EnableWebIdentityDigitalCredentials(bool);
  static bool IsWebIdentityDigitalCredentialsEnabled();
  static void EnableWebNFC(bool);
  static bool IsWebNFCEnabled();
  static void EnableWebOTP(bool);
  static bool IsWebOTPEnabled();
  static void EnableWebOTPAssertionFeaturePolicy(bool);
  static bool IsWebOTPAssertionFeaturePolicyEnabled();
  static void EnableWebShare(bool);
  static bool IsWebShareEnabled();
  static void EnableWebUSB(bool);
  static bool IsWebUSBEnabled();
  static void EnableWebUSBOnServiceWorkers(bool);
  static bool IsWebUSBOnServiceWorkersEnabled();
  static void EnableWebXR(bool);
  static bool IsWebXREnabled();
  static void EnableWebXRFrameRate(bool);
  static bool IsWebXRFrameRateEnabled();
  static void EnableWebXRFrontFacing(bool);
  static bool IsWebXRFrontFacingEnabled();
  static void EnableWebXRHandInput(bool);
  static bool IsWebXRHandInputEnabled();
  static void EnableWebXRImageTracking(bool);
  static bool IsWebXRImageTrackingEnabled();
  static void EnableWebXRLayers(bool);
  static bool IsWebXRLayersEnabled();
  static void EnableWebXRPlaneDetection(bool);
  static bool IsWebXRPlaneDetectionEnabled();
  static void EnableWebXRPoseMotionData(bool);
  static bool IsWebXRPoseMotionDataEnabled();

  WebRuntimeFeaturesBase() = delete;
};

}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_PLATFORM_WEB_RUNTIME_FEATURES_BASE_H_
